<?php

/**
 * Provide a admin settings area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://www.sortd.mobi
 * @since      2.0.0
 *
 * @package    Sortd
 * @subpackage Sortd/admin/partials
 */

?>

<?php 
if ( ! defined( 'ABSPATH' ) ) exit; 
?>

<div class="content-section">
	<div class="container-pj">
	   <div class="row">
	      <div class="col-md-12">
	         <div class="heading-main">
	            <div class="logoLft">
	               <img src="<?php echo wp_kses_data(SORTD_CSS_URL); ?>/logo.png">
	              <h5>Settings</h5>
	            </div>
	            <div class="headingNameTop df_bTn">
				<button type="button" onclick="window.open('https://supportadlabs.rwadx.com/portal/en/kb/gni-adlabs/general/sortd','_blank')" class="btn infoIcn icPd0"><i class="bi bi-info-circle"></i></button>
	               <a href="<?php echo wp_kses_data($console_url);?>" target="_blank"><button class="butn-df">Go To Console  <i class="bi bi-box-arrow-up-right"></i></button></a>
	            </div>
	         </div>
	      </div>
	   </div>

	   <div class="row">
	   		<div class="col-md-12">
	   			<div class="designSeting">
	   				<span>
	   					<i class="bi bi-palette"></i>
	   				</span>
	   				<div class="ddBox">
		   				<h1>Design and Develop</h1>
		   				<p>Customise your entire mobile web user interface and functionalities. Engage your end users with best in class mobile experience.</p>
		   			</div>
		   			<div class="mngBtns">
		   				<a href="<?php echo wp_kses_data(admin_url()).'admin.php?page=sortd-manage-settings&section=sortd_config&parameter=general_settings';?>">
			   				<button class="butn-df btn-md">Manage Design  <i class="bi bi-arrow-right-circle-fill"></i>
			   					
			   				</button>
		   				</a>
		   				<a href="<?php echo wp_kses_data(admin_url()).'admin.php?page=sortd-manage-settings&section=sortd_manage_templates';?>">
		   				<button class="butn-df btn-Thm">Themes <i class="bi bi-arrow-right-circle-fill"></i></button></a>
		   			</div>
	   			</div>
	   		</div>

	   		<div class="col-md-6">
	   			<div class="designCatag_oder">
	   				<h3>Manage Categories</h3>
	   				<p>Manage sync / unsync of the categories in mobile.</p>
	   				<span>
	   					<a href="<?php echo wp_kses_data(admin_url()).'admin.php?page=sortd-manage-settings&section=sortd_manage_categories';?>"><i class="bi bi-arrow-right-circle-fill"></i></a>
	   				</span>
	   			</div>

	   			<div class="designCatag_oder">
	   				<h3>Credentials <span class="verifyAlt">Already Verified</span></h3>
	   				<p>Validate your unique token & key to keep your account secure.</p>
	   				<span>
	   					<a href="<?php echo wp_kses_data(admin_url()).'admin.php?page=sortd-manage-settings&section=sortd_credential_settings';?>"><i class="bi bi-arrow-right-circle-fill"></i></a>
	   				</span>
	   			</div>

	   			<div class="designCatag_oder">
					   <h3> Set Mobile Search Console  </h3>
					   <p> Create search visibilty for advanced mobile setup. </p>
					   <span>
					   <a target="_blank" href="https://search.google.com/search-console/about"><i class="bi bi-arrow-right-circle-fill"></i></a>
					   </span>
				   </div>

				<?php 	$project_id = Sortd_Helper::get_project_id(); 
						$value = get_option('sortd_author_sync_success_'.$project_id);
						$notoptions = wp_cache_get( 'notoptions', 'options' );
						if ( isset( $notoptions['sortd_author_sync_success_'.$project_id] ) ) {
							$value = 0;
						} else {
							$value = $value;
						}
				
				
				if($value == 0) { ?>
				<div class="designCatag_oder authorsSettings">
	   				<h3>Manage Authors</h3>
	   				<p>Sync old authors data.</p>
	   				<span>
					   <span class="dataSuccess"></span>
					    <span class="dataloader" style="display:none" >
                        <span class="">Please Wait...</span>
                        <img width="35px" src="<?php echo wp_kses_data(SORTD_CSS_URL);?>/load.gif" id="loader">
						</span> 
	   					<a href="javascript:void(0)" class="manageAuthors"><i class="bi bi-arrow-right-circle-fill"></i></a>
	   				</span>
	   			</div>
				<?php } ?>

	   		</div>
	   		<?php 
                            if($redirection_enabled == 1){ 

                                    $status_btn ="Active";
                                    $class_name = "setactvBtn";

                            } else if($redirection_enabled == 0){

                                    $status_btn ="Inactive";
                                    $class_name = "setdeactvBtn";


                            }
                        ?>
	   		<div class="col-md-6">
	   			<div class="designCatag_oder">
	   				<h3>Mobile Subdomain Status</h3>
	   				<p style="width:44%;">Control your website redirection to mobile urls. </p>
	   				<a href="<?php echo wp_kses_data(admin_url()).'admin.php?page=sortd-manage-settings&section=sortd_redirection';?>" class="<?php echo wp_kses_data($class_name);?>"><?php echo wp_kses_data($status_btn);?></a>
	   				<hr class="bdr2">

	   				<h4>Mobile Url: </h4> <span class="mobDom"><?php echo wp_kses_data($host);?></span>
	   				<a href="<?php echo wp_kses_data(admin_url()).'admin.php?page=sortd-manage-settings&section=sortd_manage_domains';?>" class="mngDom" style="margin-top:23px;margin-bottom:12px;">Manage Mobile Domain <i class="bi bi-arrow-right-circle-fill"></i></a>
					   
				</div>
				<div class="designCatag_oder">
	   				<h3>Manage Advanced Settings</h3>
	   				<p>Click here to manage your extended feature settings.</p>
	   				<span>
	   					<a target="_blank" href="<?php echo wp_kses_data($console_url);?>/features/manager?project=<?php echo wp_kses_data($project_slug);?>"><i class="bi bi-arrow-right-circle-fill"></i></a>
	   				</span>
	   			</div>
	   		</div>
		
	   </div>
	</div>
</div>

